# TPK4186 - Advanced Tools for Performance Engineering
# TargetFibonacci.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Recursive version
def FibonacciRecursive(N):
  if N==0:
    return 1
  if N==1:
    return 1
  return FibonacciRecursive(N-1) + FibonacciRecursive(N-2)

print("FibonacciRecursive(30) = " + str(FibonacciRecursive(30)))
print("FibonacciRecursive(32) = " + str(FibonacciRecursive(32)))
print("FibonacciRecursive(34) = " + str(FibonacciRecursive(34)))
print("FibonacciRecursive(36) = " + str(FibonacciRecursive(36)))

# Version with a loop
def FibonacciLoop(N):
  F0 = 1
  F1 = 1
  for I in range(2, N+1):
    F2 = F1 + F0
    F0 = F1
    F1 = F2
  return F1

print("FibonacciLoop(30) = " + str(FibonacciLoop(30)))
print("FibonacciLoop(32) = " + str(FibonacciLoop(32)))
print("FibonacciLoop(34) = " + str(FibonacciLoop(34)))
print("FibonacciLoop(36) = " + str(FibonacciLoop(36)))
