# TPK4186 - Advanced Tools for Performance Engineering
# FileCounts.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# This work is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Function
def FileCounts(fileName):
  try:
    file = open(fileName, "r") 
  except: 
    print("Unable to open file " + fileName)
    return 1
  characterCount = 0
  wordCount = 0
  sentenceCount = 0
  paragraphCount = 0
  isNewWord = True
  isNewSentence = True
  isNewParagraph = True
  for line in file:
    for chr in line:
      if chr=='\n':
        isNewWord = True
        isNewParagraph = True
        isNewSentence = True
      elif chr==".":
        characterCount += 1
        isNewWord = True
        isNewSentence = True
      elif not chr.isalpha():
        characterCount += 1
        isNewWord = True
      else:
        characterCount += 1
        if isNewWord:
          isNewWord = False
          wordCount += 1
        if isNewSentence:
          isNewSentence = False
          sentenceCount += 1
        if isNewParagraph:
          isNewParagraph = False
          paragraphCount += 1
  file.close()
  print("characters:\t" + str(characterCount))
  print("words:     \t" + str(wordCount))
  print("sentences: \t" + str(sentenceCount))
  print("paragraphs:\t" + str(paragraphCount))
  return 0

# Test
FileCounts("Lorem Ipsum.txt")

