# TPK4186 - Advanced Tools for Performance Engineering
# FileSmartFormatter.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.


# Function
def FileSmartFormatter(inputFileName, outputFileName):
  try:
    inputFile = open(inputFileName, "r") 
  except: 
    print("Unable to open file " + inputFileName)
    return
  try:
    outputFile = open(outputFileName, "w") 
  except: 
    print("Unable to open file " + outputFileName)
    inputFile.close()
    return
  for line in inputFile:
    startIndex = 0
    currentIndex = 0
    while currentIndex<len(line):
      if currentIndex==startIndex+80:
        while line[currentIndex]!=" ":
          currentIndex -= 1
        PrintLineSlice(line, startIndex, currentIndex, outputFile)
        outputFile.write("\n")
        startIndex = currentIndex
      currentIndex += 1
    PrintLineSlice(line, startIndex, currentIndex, outputFile)
  outputFile.flush()
  outputFile.close()
  inputFile.close()

def PrintLineSlice(line, startIndex, endIndex, outputFile):
  beginningOfLine = True
  currentIndex = startIndex
  while currentIndex!=endIndex:
    if beginningOfLine:
      if line[currentIndex]!=" ":
        outputFile.write(line[currentIndex])
        beginningOfLine = False
    else:
      outputFile.write(line[currentIndex])
    currentIndex += 1
  
# Test
FileSmartFormatter("Lorem Ipsum.txt", "Lorem Ipsum - Formatted.txt")
