# TPK4186 - Advanced Tools for Performance Engineering
# FoxInSocks.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import re

sentence = """When beetles battle beetles in a puddle paddle battle and
the beetle battle puddle is a puddle in a bottle, they call this
a tweetle beetle bottle puddle paddle battle muddle."""

result = re.search(r"\w*u\w*", sentence)
if result:
  print("I found " + result.group() + " at " + str(result.start()))
else:
  print("I cannot find that")

result = re.match(r"W\w*", sentence)
if result:
  print("Yep, the sentence starts with " + result.group())
else:
  print("Nope")

words = re.split(r"[\s.]+", sentence)
print(words)

words = re.findall(r"b\w+", sentence)
print(words)

newSentence = re.sub(r"bottle", "big bottle", sentence)
print(newSentence)

result = re.search(r"(\w*u\w*)|(\w*tt\w*)", sentence)
if result:
  if result.group(1):
    print("I found " + result.group(1))
  if result.group(2):
    print("I found " + result.group(2))
else:
  print("I found none of them")

result = re.search(r"[^ dt]*([dt])\1[^ dt]* [^ dt]*([dt])\2[^ dt]*", sentence)
if result:
  print("I found '" + result.group(0) + "' with:")
  for n in range(1, 3):
    if result.group(n):
      print("group " + str(n) + " = " + result.group(n))
else:
  print("I found none of them")

