# TPK4186 - Advanced Tools for Performance Engineering
# LicensePlates.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re

# Reading and categorizing plates
licensePlateFileName = "licensePlates.txt"
regularVehicleFileName = "regularVehicles.txt"
motorcycleFileName = "motorcycles.txt"
otherVehicleFileName = "otherVehicles.txt"

try:
  licensePlateFile = open(licensePlateFileName, "r")
except:
  print("Unable to open file " + licensePlateFileName)
  sys.exit()

try:
  regularVehicleFile = open(regularVehicleFileName, "w")
except:
  print("Unable to open file " + regularVehicleFileName)
  sys.exit()

try:
  motorcycleFile = open(motorcycleFileName, "w")
except:
  print("Unable to open file " + motorcycleFileName)
  sys.exit()

try:
  otherVehicleFile = open(otherVehicleFileName, "w")
except:
  print("Unable to open file " + otherVehicleFileName)
  sys.exit()

for line in licensePlateFile:
  licensePlate = line.rstrip()
  m = re.match(r"([A-Z]{2})[ ]*([0-9]{5})", licensePlate)
  if m:
    regularVehicleFile.write(m.group(1) + " " + m.group(2) + "\n")
  else:
    m = re.match(r"([A-Z]{2})[ ]*([0-9]{4})", licensePlate)
    if m:
      motorcycleFile.write(m.group(1) + " " + m.group(2) + "\n")
    else:
      otherVehicleFile.write(licensePlate + "\n")

regularVehicleFile.flush()
motorcycleFile.flush()
otherVehicleFile.flush()

licensePlateFile.close()
regularVehicleFile.close()
motorcycleFile.close()
otherVehicleFile.close()
