# TPK4186 - Advanced Tools for Performance Engineering
# OneSentencePerLine2.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re

# Open the input file
inputFileName = "Lorem Ipsum.txt"
inputFile = open(inputFileName, "r")
if inputFile==None:
  sys.stderr.write("Unable to open file '%s'\n" % inputFileName)
  sys.exit()

# Open the output file
outputFileName = "Lorem Ipsum -- formatted.txt"
outputFile = open(outputFileName, "w")
if outputFile==None:
  sys.stderr.write("Unable to open file '%s'\n" % outputFileName)
  inputFile.close()
  sys.exit()

# Read the input file line by line
# Add an extra newline character after each dot
# Write the result into the output file
for inputLine in inputFile:
  inputLine = inputLine.rstrip()
  outputLine = re.sub("\. ", ".\n", inputLine)
  outputLine = outputLine.lstrip()
  outputFile.write(outputLine + "\n")

# Close the input and output files
outputFile.close()
inputFile.close()
