# TPK4186 - Advanced Tools for Performance Engineering
# SpeechCleaner.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import re

# Open the input file
inputFileName = "I Have a Dream.txt"
inputFile = open(inputFileName, "r")
if inputFile==None:
  sys.stderr.write("Unable to open file '%s'\n" % inputFileName)
  sys.exit()

# Open the output file
outputFileName = re.sub(r"\.txt", "", inputFileName) + " -- cleaned.txt"
outputFile = open(outputFileName, "w")
if outputFile==None:
  sys.stderr.write("Unable to open file '%s'\n" % outputFileName)
  inputFile.close()
  sys.exit()

for inputLine in inputFile:
  inputLine = inputLine.rstrip()
  outputLines = re.split(r"\.", inputLine)
  for outputLine in outputLines:
    if outputLine=="":
      continue
    outputLine = re.sub(r"\([^)]*\)", "", outputLine) # removes parentheses
    outputLine = re.sub(r"\[[^]]*\]", "", outputLine) # removes square brackets 
    outputLine = re.sub(r"[ ]+", " ", outputLine)     # removes extra-spaces
    outputLine = re.sub(r"^ ", "", outputLine)        # removes spaces at the beginning of lines
    outputLine = re.sub(r" ,", ",", outputLine)       # removes spaces before commas
    outputLine = re.sub(r" $", "", outputLine)        # removes spaces at the end of lines
    if outputLine=="":
      outputFile.write("\n")
    else:
      outputFile.write(outputLine + ".\n")

# Close the input and output files
outputFile.close()
inputFile.close()
